<template>
    <single-pane class="contracts-list">
        <div class="content">
            <div class="panel"
                 v-for="(item, key) in 10"
                 :key="key">
                <div>
                    <ob-address-input
                            title="Откуда"
                            :prefixIcon="addressFrom && addressFrom.icon || ''"
                            placeholder="Введите адрес"
                            :show-map="false"
                            @input="setAddressFrom"
                            @on-change-address="setAddressFrom"
                            :data-qa="'obAddressInput_'+item"
                    />
                    <ob-select
                            v-model="transport"
                            label="Вид автотранспорта"
                            :items="transports"
                            placeholder="Выберите из списка"
                            position="top"
                            @input="changeTransport"
                            :data-qa="'transport_'+item"
                    />
                    <ob-select
                            v-model="transportType"
                            label="Тип автотранспорта"
                            :items="transportTypes"
                            placeholder="Выберите из списка"
                            position="top"
                            :disabled="!transport"
                            @input="setTransportType"
                            :data-qa="'transportType_'+item"
                    />
                </div>
            </div>
        </div>
    </single-pane>
</template>
<script>
    import SinglePane from 'common-components/src/obComponents/obSinglePanels'
    import obAddressInput from 'common-components/src/obComponents/obAddressInput';
    import {getIconByLocation} from '@/helpers';
    import obSelect from 'common-components/src/obComponents/obSelect';
    import api from "@/api";
    import {mapGetters} from "vuex";

    export default {
        name: 'testpage',
        components: {
            obAddressInput,
            SinglePane,
            obSelect,
        },
        data() {
            return {
                addressFrom: {
                    coordinates: {},
                    icon: "pin",
                    label: "",
                    isValid: true,
                    popoverMessage: "",
                },
                transportTypes: [],
                transportType: "",
                transport: "",
                transports: [],
                activeTransportationWay: "FTL",
                formData: {
                    bodySaveDraft: {
                        serviceParams: {
                            serviceTypeUuid: ''
                        }
                    }
                }
            }
        },
        created() {
            api.dictionaries.resources.getResourceSpeciesByClass('e7519b46-faf4-11e9-8f0b-362b9e155667')
                .then(res => {
                    this.transports = res;
                    const def = res.find(item => {
                        return item.title === 'Фургон'
                    });
                    this.defaultTransport = def.uuid;
                    this.transport = def.uuid;
                    this.changeTransport();
                }).catch(() => {
                this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
            });
        },
        computed: {
            ...mapGetters({
                role: "user/role"
            }),
        },
        methods: {
            async onTransportationWaychanged() {
                this.showTariff = false;
                this.tariffEmpty = false;
                this.tariffError = false;
                this.isLogchainError = false;
                this.formData.bodySaveDraft.serviceParams.serviceUuid = "";
                this.formData.bodySaveDraft.transportationWay = this.activeTransportationWay;
                // await this.setTransports();
                const res = await api.orders.getTransport(
                    this.formData.bodySaveDraft.transportationWay
                );

                this.transports = res;

                this.formData.bodySaveDraft.serviceParams.serviceTypeUuid = this.transports[0].uuid;

                // await this.changeTransport();
                const types = await api.orders.getTransportTypes(
                    'b5cf940e-1bfc-4e95-a07b-0dc8bc4c4e47',
                    this.formData.bodySaveDraft.serviceParams.serviceTypeUuid
                );
                this.transportTypes = this.groupTransportTypes(types);
                if (this.formData.bodySaveDraft.transportationWay === "CONTAINER") {
                    this.formData.bodySaveDraft.isPrivateContainer = true;
                }
                if (
                    this.formData.bodySaveDraft.transportationWay === "CONTAINER" ||
                    this.formData.bodySaveDraft.transportationWay === "RAIL"
                ) {
                    api.resources
                        .getForwardingUnitList()
                        .then((res) => {
                            this.accountingItems = res.data.content.reduce((acc, item) => {
                                acc.push({uuid: item.uuid, title: item.denomination});
                                return acc;
                            }, []);
                        })
                        .catch((e) => {
                            console.error(e);
                            this.$notification({
                                type: "system_notification_error",
                                message: "Ошибка загрузки данных",
                            });
                        });
                }
            },
            async changeTransport() {
                this.formData.bodySaveDraft.serviceParams.serviceTypeUuid = this.transport;
                try {
                    this.getTranspotTypes();
                    this.showTariff = false;
                    this.tariffEmpty = false;
                    this.tariffError = false;
                } catch (e) {
                    console.error(e);
                    this.$notification({
                        type: "system_notification_error",
                        message: "Ошибка загрузки данных",
                    });
                }
                this.onTransportationWaychanged()
            },
            async getTranspotTypes() {
                try {
                    const types = await api.orders.getTransportTypes(
                        'b5cf940e-1bfc-4e95-a07b-0dc8bc4c4e47',
                        this.formData.bodySaveDraft.serviceParams.serviceTypeUuid
                    );
                    this.transportTypes = this.groupTransportTypes(types);
                } catch (e) {
                    console.error(e);
                }
            },
            setAddressFrom(location) {
                if (location.locationUuid) {
                    this.addressFrom = location;
                    this.addressFrom.icon = getIconByLocation(location.location_type_uuid);
                    this.changeLocations();
                } else {
                    console.error('location doesnt have uuid');
                }
            },
            setTransportType() {
                this.showTariff = false;
            },
            groupTransportTypes(types) {
                const GROUP_SIZE_MIN = 6;
                let groups = [];
                const groupsMap = {};
                if (types) {
                    if (types.length > GROUP_SIZE_MIN) {
                        types.forEach(type => {
                            if (!groupsMap[type.resourceSubtypeUuid]) {
                                groupsMap[type.resourceSubtypeUuid] = {
                                    title: type.resourceSubtypeTitle,
                                    defaultGroupElementUuid: null,
                                    hideSelectButton: true,
                                    children: []
                                };
                            }
                            groupsMap[type.resourceSubtypeUuid].children.push(type);
                        })

                        Object.keys(groupsMap).forEach(key => {
                            let group = groupsMap[key];
                            let defaulItem = group.children.filter(item => item.isDefaultForSubtype);
                            if (defaulItem.length === 1) {
                                group.defaultGroupElementUuid = defaulItem[0].uuid;
                                group.hideSelectButton = false;
                            }
                            groups.push(group);
                        })
                    } else {
                        groups = types;
                    }
                }

                return groups;
            },
        }
    }
</script>

<style scoped="scoped">
    .content{
        padding: 300px 0 0 0;
        margin: 15px 15px
    }
    .panel {
        margin: 15px 0;
        padding: 0 15px;
        width: 50%;
        float: left;
        display: inline-block;
    }
</style>
